import axios from 'axios'
import store from '@/store/store.js'

const instance = axios.create({
  headers: { 'Authorization': "Bearer " + localStorage.getItem('stored_token') },
  baseURL: 'http://localhost:8000/api'
})

instance.interceptors.response.use(function (response) {
  return response;
}, function (error) {
  // Affichage des erreurs (snackbar)
  Object.values(error.response.data).forEach(errMsg => {
    store.commit('moduleSnackbar/toggle', { open: true, message: errMsg[0], type: 'error' }, { root: true })
  })
  return Promise.reject(error)
})

export default instance