import axios from '../../../plugins/axios'

export function getApplications(context) {
  axios({
    method: 'get',
    url: '/applicants'
  })
    .then(response => {
      context.commit('setApplications', response.data)
    })
}

export function getCurrentApplicationData(context, data) {
  axios({
    method: 'get',
    url: '/applicant/' + data.id
  })
    .then(response => {
      context.commit('setCurrentApplicationData', response.data.personal_data)
    })
}

export function getCurrentApplicationComments(context, data) {
  axios({
    method: 'get',
    url: '/applicant/' + data.id + '/comments'
  })
    .then(response => {
      context.commit('setCurrentApplicationComments', response.data)
    })
}

export function getCurrentApplicationMarker(context, data) {
  axios({
    method: 'get',
    url: '/applicant/' + data.id + '/marker'
  })
    .then(response => {
      context.commit('setCurrentApplicationMarker', response.data.marker)
    })
}

export function getAvailableStatus(context) {
  axios({
    method: 'get',
    url: '/status'
  })
    .then(response => {
      context.commit('setAvailableStatus', response.data)
    })
}

export function changeApplicationStatus(context, data) {
  axios({
    method: 'patch',
    url: '/status/applicant/' + data.id,
    data: data
  })
    .then(response => {
      context.commit('moduleSnackbar/toggle', { open: true, message: response.data.message, type: 'success' }, { root: true })
    })
}

export function deleteApplication(context, data) {
  axios({
    method: 'delete',
    url: '/applicant/' + data.id,
    data: data
  })
    .then(response => {
      context.commit('moduleSnackbar/toggle', { open: true, message: response.data.message, type: 'success' }, { root: true })
    })
}