import axios from '../../../plugins/axios'

export function login() {
  axios({
    method: 'get',
    url: '/auth/login'
  })
    .then(response => {
      if (!response.data.token) {
        window.location = 'http://localhost:8000/api/auth/login'
      } else {
        localStorage.setItem('stored_token', response.data.token);
        localStorage.setItem('last_login', Date.now());
        location.reload()
      }
    })
}

export function logout() {
  localStorage.removeItem('stored_token');
  window.location = 'https://tequila.epfl.ch/logout'
}

export function getUserData(context) {
  return new Promise((resolve, reject) => {
    axios({
      method: 'get',
      url: '/user'
    })
      .then(response => {
        context.commit('setUserData', response.data)
        resolve(response.data)
      })
      .catch(err => {
        reject(err)
      })
  })
}

export function getUserPermittedJobs(context) {
  axios({
    method: 'get',
    url: '/user/permittedjobs'
  })
    .then(response => {
      context.commit('setPermittedJobs', response.data)
    })
}